#ifndef INCLUDE_H_SAXContentHandlerAdaptor
#define INCLUDE_H_SAXContentHandlerAdaptor

#include <msxml2.h>

#include "tstring.hpp"
#include "SAXContentHandler.hpp"

class SAXContentHandlerAdaptor : public ISAXContentHandler
{
private:

	DWORD ref_;

	ISAXLocator* pLocator_;

	SAXContentHandler& handler_;

	virtual ~SAXContentHandlerAdaptor();

public:
	SAXContentHandlerAdaptor( SAXContentHandler& v_handler );

	virtual HRESULT __stdcall QueryInterface(const IID& iid, void** ppvObj );

	virtual ULONG __stdcall AddRef(void);

	virtual ULONG __stdcall Release(void);

	virtual HRESULT __stdcall putDocumentLocator(ISAXLocator* v_pLocator );

	virtual HRESULT __stdcall startDocument(void);

	virtual HRESULT __stdcall endDocument(void);

	virtual HRESULT __stdcall startPrefixMapping(const wchar_t* pArg0, int arg0len, const wchar_t* pArg1, int arg1len );

	virtual HRESULT __stdcall endPrefixMapping(const wchar_t* arg0, int arg0len );

	virtual HRESULT __stdcall startElement(
		const wchar_t* pNs,
		int nsLen,
		const wchar_t* pwchLocalName,
		int cchLocalName,
		const wchar_t* pQName,
		int QNameLen,
		ISAXAttributes* pAttr
		);

	virtual HRESULT __stdcall endElement(
		const wchar_t *pNs,
		int nsLen,
		const wchar_t* pwchLocalName,
		int cchLocalName,
		const wchar_t *pQName,
		int QNameLen
		);

	virtual HRESULT __stdcall characters(const wchar_t* p, int len );

	virtual HRESULT __stdcall ignorableWhitespace(const wchar_t* p, int len );

	virtual HRESULT __stdcall processingInstruction(
		const wchar_t* pTarget,
		int targetLen,
		const wchar_t* pData,
		int dataLen
		);

	virtual HRESULT __stdcall skippedEntity(const wchar_t *pName, int nameLen );
};


#endif
